configure 9.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334
  1. #!/bin/sh
  2. usage () {
  3. cat <<EOF
  4. Usage: $0 [OPTION]... [VAR=VALUE]... [TARGET]
  5. To assign environment variables (e.g., CC, CFLAGS...), specify them as
  6. VAR=VALUE. See below for descriptions of some of the useful variables.
  7. Defaults for the options are specified in brackets.
  8. Installation directories:
  9. --prefix=PREFIX main installation prefix [/usr/local/musl]
  10. --exec-prefix=EPREFIX installation prefix for executable files [PREFIX]
  11. Fine tuning of the installation directories:
  12. --bindir=DIR user executables [EPREFIX/bin]
  13. --libdir=DIR library files for the linker [PREFIX/lib]
  14. --includedir=DIR include files for the C compiler [PREFIX/include]
  15. --syslibdir=DIR location for the dynamic linker [/lib]
  16. System types:
  17. --target=TARGET configure to run on target TARGET [detected]
  18. --host=HOST same as --target
  19. Optional features:
  20. --enable-debug build with debugging information [disabled]
  21. --enable-warnings build with recommended warnings flags [disabled]
  22. --enable-gcc-wrapper build musl-gcc toolchain wrapper [auto]
  23. --disable-shared inhibit building shared library [enabled]
  24. --disable-static inhibit building static library [enabled]
  25. Some influential environment variables:
  26. CC C compiler command [detected]
  27. CFLAGS C compiler flags [-Os -pipe ...]
  28. CROSS_COMPILE prefix for cross compiler and tools [none]
  29. LIBCC compiler runtime library [detected]
  30. Use these variables to override the choices made by configure.
  31. EOF
  32. exit 0
  33. }
  34. # Helper functions
  35. echo () { printf "%s\n" "$*" ; }
  36. fail () { echo "$*" ; exit 1 ; }
  37. fnmatch () { eval "case \"\$2\" in $1) return 0 ;; *) return 1 ;; esac" ; }
  38. cmdexists () { type "$1" >/dev/null 2>&1 ; }
  39. trycc () { test -z "$CC" && cmdexists "$1" && CC=$1 ; }
  40. setdir () {
  41. if eval "test -z \"\${$1}\"" ; then eval "$1=\$2"
  42. else eval "fnmatch '*/' \"\${$1}\"" && eval "$1=\${$1%/}" ; fi
  43. }
  44. tryflag () {
  45. printf "checking whether compiler accepts %s... " "$2"
  46. echo "typedef int x;" > "$tmpc"
  47. if "$CC" "$2" -c -o /dev/null "$tmpc" 2>/dev/null ; then
  48. printf "yes\n"
  49. eval "$1=\"\${$1} \$2\""
  50. eval "$1=\${$1# }"
  51. return 0
  52. else
  53. printf "no\n"
  54. return 1
  55. fi
  56. }
  57. tryldflag () {
  58. printf "checking whether linker accepts %s... " "$2"
  59. echo "typedef int x;" > "$tmpc"
  60. if "$CC" -nostdlib -shared "$2" -o /dev/null "$tmpc" 2>/dev/null ; then
  61. printf "yes\n"
  62. eval "$1=\"\${$1} \$2\""
  63. eval "$1=\${$1# }"
  64. return 0
  65. else
  66. printf "no\n"
  67. return 1
  68. fi
  69. }
  70. # Beginning of actual script
  71. CFLAGS_C99FSE=
  72. CFLAGS_AUTO=
  73. LDFLAGS_AUTO=
  74. prefix=
  75. exec_prefix=
  76. bindir=
  77. libdir=
  78. includedir=
  79. syslibdir=
  80. target=
  81. debug=no
  82. warnings=
  83. shared=yes
  84. static=yes
  85. for arg ; do
  86. case "$arg" in
  87. --help) usage ;;
  88. --prefix=*) prefix=${arg#*=} ;;
  89. --exec-prefix=*) exec_prefix=${arg#*=} ;;
  90. --bindir=*) bindir=${arg#*=} ;;
  91. --libdir=*) libdir=${arg#*=} ;;
  92. --includedir=*) includedir=${arg#*=} ;;
  93. --syslibdir=*) syslibdir=${arg#*=} ;;
  94. --enable-shared|--enable-shared=yes) shared=yes ;;
  95. --disable-shared|--enable-shared=no) shared=no ;;
  96. --enable-static|--enable-static=yes) static=yes ;;
  97. --disable-static|--enable-static=no) static=no ;;
  98. --enable-debug|--enable-debug=yes) debug=yes ;;
  99. --disable-debug|--enable-debug=no) debug=no ;;
  100. --enable-warnings|--enable-warnings=yes) warnings=yes ;;
  101. --disable-warnings|--enable-warnings=no) warnings=no ;;
  102. --enable-gcc-wrapper|--enable-gcc-wrapper=yes) wrapper=yes ;;
  103. --disable-gcc-wrapper|--enable-gcc-wrapper=no) wrapper=no ;;
  104. --enable-*|--disable-*|--with-*|--without-*|--*dir=*|--build=*) ;;
  105. --host=*|--target=*) target=${arg#*=} ;;
  106. -* ) echo "$0: unknown option $arg" ;;
  107. CC=*) CC=${arg#*=} ;;
  108. CFLAGS=*) CFLAGS=${arg#*=} ;;
  109. CPPFLAGS=*) CPPFLAGS=${arg#*=} ;;
  110. LDFLAGS=*) LDFLAGS=${arg#*=} ;;
  111. CROSS_COMPILE=*) CROSS_COMPILE=${arg#*=} ;;
  112. LIBCC=*) LIBCC=${arg#*=} ;;
  113. *=*) ;;
  114. *) target=$arg ;;
  115. esac
  116. done
  117. setdir prefix /usr/local/musl
  118. setdir exec_prefix '$(prefix)'
  119. setdir bindir '$(exec_prefix)/bin'
  120. setdir libdir '$(prefix)/lib'
  121. setdir includedir '$(prefix)/include'
  122. setdir syslibdir '/lib'
  123. #
  124. # Get a temp filename we can use
  125. #
  126. i=0
  127. set -C
  128. while : ; do i=$(($i+1))
  129. tmpc="./conf$$-$PPID-$i.c"
  130. 2>/dev/null > "$tmpc" && break
  131. test "$i" -gt 50 && fail "$0: cannot create temporary file $tmpc"
  132. done
  133. set +C
  134. trap 'rm "$tmpc"' EXIT INT QUIT TERM HUP
  135. #
  136. # Find a C compiler to use
  137. #
  138. printf "checking for C compiler... "
  139. trycc ${CROSS_COMPILE}gcc
  140. trycc ${CROSS_COMPILE}c99
  141. trycc ${CROSS_COMPILE}cc
  142. printf "%s\n" "$CC"
  143. test -n "$CC" || { echo "$0: cannot find a C compiler" ; exit 1 ; }
  144. #
  145. # Only build musl-gcc wrapper if toolchain does not already target musl
  146. #
  147. if test -z "$wrapper" ; then
  148. printf "checking whether compiler is gcc... "
  149. if fnmatch '*gcc\ version*' "$("$CC" -v 2>&1)" ; then
  150. echo yes
  151. printf "checking whether to build musl-gcc wrapper... "
  152. wrapper=yes
  153. while read line ; do
  154. case "$line" in */ld-musl-*) wrapper=no ;; esac
  155. done <<EOF
  156. $($CC -dumpspecs)
  157. EOF
  158. echo $wrapper
  159. else
  160. echo no
  161. fi
  162. fi
  163. #
  164. # Find the target architecture
  165. #
  166. printf "checking target system type... "
  167. test -n "$target" || target=$("$CC" -dumpmachine 2>/dev/null) || target=unknown
  168. printf "%s\n" "$target"
  169. #
  170. # Convert to just ARCH
  171. #
  172. case "$target" in
  173. arm*) ARCH=arm ;;
  174. i?86*) ARCH=i386 ;;
  175. x86_64*) ARCH=x86_64 ;;
  176. mips-*|mipsel-*) ARCH=mips ;;
  177. microblaze-*) ARCH=microblaze ;;
  178. unknown) fail "$0: unable to detect target arch; try $0 --target=..." ;;
  179. *) fail "$0: unknown or unsupported target \"$target\"" ;;
  180. esac
  181. #
  182. # Try to get a conforming C99 freestanding environment
  183. #
  184. tryflag CFLAGS_C99FSE -std=c99
  185. tryflag CFLAGS_C99FSE -nostdinc
  186. tryflag CFLAGS_C99FSE -ffreestanding \
  187. || tryflag CFLAGS_C99FSE -fno-builtin
  188. tryflag CFLAGS_C99FSE -fexcess-precision=standard \
  189. || { test "$ARCH" = i386 && tryflag CFLAGS_C99FSE -ffloat-store ; }
  190. tryflag CFLAGS_C99FSE -frounding-math
  191. #
  192. # Setup basic default CFLAGS: debug, optimization, and -pipe
  193. #
  194. if fnmatch '-O*|*\ -O*' "$CFLAGS_AUTO $CFLAGS" ; then :
  195. else
  196. tryflag CFLAGS_AUTO -Os || tryflag CFLAGS_AUTO -O2
  197. fi
  198. test "x$debug" = xyes && CFLAGS_AUTO="-g"
  199. tryflag CFLAGS_AUTO -pipe
  200. #
  201. # If debugging is disabled, omit frame pointer. Modern GCC does this
  202. # anyway on most archs even when debugging is enabled since the frame
  203. # pointer is no longer needed for debugging.
  204. #
  205. if fnmatch '-g*|*\ -g*' "$CFLAGS_AUTO $CFLAGS" ; then :
  206. else
  207. tryflag CFLAGS_AUTO -fomit-frame-pointer
  208. fi
  209. #
  210. # Modern GCC wants to put DWARF tables (used for debugging and
  211. # unwinding) in the loaded part of the program where they are
  212. # unstrippable. These options force them back to debug sections (and
  213. # cause them not to get generated at all if debugging is off).
  214. #
  215. tryflag CFLAGS_AUTO -fno-unwind-tables
  216. tryflag CFLAGS_AUTO -fno-asynchronous-unwind-tables
  217. #
  218. # The GNU toolchain defaults to assuming unmarked files need an
  219. # executable stack, potentially exposing vulnerabilities in programs
  220. # linked with such object files. Fix this.
  221. #
  222. tryflag CFLAGS_AUTO -Wa,--noexecstack
  223. #
  224. # Some optimization levels add bloated alignment that hurt performance
  225. #
  226. tryflag CFLAGS_AUTO -falign-functions=1
  227. tryflag CFLAGS_AUTO -falign-labels=1
  228. tryflag CFLAGS_AUTO -falign-loops=1
  229. tryflag CFLAGS_AUTO -falign-jumps=1
  230. #
  231. # On x86, make sure we don't have incompatible instruction set
  232. # extensions enabled by default. This is bad for making static binaries.
  233. # We cheat and use i486 rather than i386 because i386 really does not
  234. # work anyway (issues with atomic ops).
  235. #
  236. if test "$ARCH" = "i386" ; then
  237. fnmatch '-march=*|*\ -march=*' "$CFLAGS" || tryflag CFLAGS_AUTO -march=i486
  238. fnmatch '-mtune=*|*\ -mtune=*' "$CFLAGS" || tryflag CFLAGS_AUTO -mtune=generic
  239. fi
  240. if test "x$warnings" = xyes ; then
  241. tryflag CFLAGS_AUTO -Wall
  242. tryflag CFLAGS_AUTO -Wpointer-arith
  243. tryflag CFLAGS_AUTO -Wcast-align
  244. tryflag CFLAGS_AUTO -Wno-parentheses
  245. tryflag CFLAGS_AUTO -Wno-uninitialized
  246. tryflag CFLAGS_AUTO -Wno-missing-braces
  247. tryflag CFLAGS_AUTO -Wno-unused-value
  248. tryflag CFLAGS_AUTO -Wno-unused-but-set-variable
  249. tryflag CFLAGS_AUTO -Wno-unknown-pragmas
  250. fi
  251. # Some patched GCC builds have these defaults messed up...
  252. tryflag CFLAGS_AUTO -fno-stack-protector
  253. tryldflag LDFLAGS_AUTO -Wl,--hash-style=both
  254. # Disable dynamic linking if ld is broken and can't do -Bsymbolic-functions
  255. LDFLAGS_DUMMY=
  256. tryldflag LDFLAGS_DUMMY -Wl,-Bsymbolic-functions || {
  257. printf "warning: disabling dynamic linking support\n"
  258. shared=no
  259. }
  260. # Find compiler runtime library
  261. test -z "$LIBCC" && tryldflag LIBCC -lgcc && tryldflag LIBCC -lgcc_eh
  262. test -z "$LIBCC" && tryldflag LIBCC -lcompiler_rt
  263. printf "using compiler runtime libraries: %s\n" "$LIBCC"
  264. printf "creating config.mak... "
  265. exec 3>&1 1>config.mak
  266. cat << EOF
  267. # This version of config.mak was generated by configure
  268. # Any changes made here will be lost if configure is re-run
  269. ARCH = $ARCH
  270. prefix = $prefix
  271. exec_prefix = $exec_prefix
  272. bindir = $bindir
  273. libdir = $libdir
  274. includedir = $includedir
  275. syslibdir = $syslibdir
  276. CC = $CC
  277. CFLAGS= $CFLAGS_AUTO $CFLAGS
  278. CFLAGS_C99FSE = $CFLAGS_C99FSE
  279. CPPFLAGS = $CPPFLAGS
  280. LDFLAGS = $LDFLAGS_AUTO $LDFLAGS
  281. CROSS_COMPILE = $CROSS_COMPILE
  282. LIBCC = $LIBCC
  283. EOF
  284. test "x$static" = xno && echo "STATIC_LIBS ="
  285. test "x$shared" = xno && echo "SHARED_LIBS ="
  286. test "x$wrapper" = xno && echo "ALL_TOOLS ="
  287. test "x$wrapper" = xno && echo "TOOL_LIBS ="
  288. exec 1>&3 3>&-
  289. printf "done\n"